function SSRCCOT_VOT2019

setup_paths();
debug = false;
% *************************************************************
% VOT: Always call exit command at the end to terminate Matlab!
% *************************************************************
cleanup = onCleanup(@() exit() );

seq.format = 'vot';

RandStream.setGlobalStream(RandStream('mt19937ar', 'Seed', sum(clock)));

% VOT: Get initialization data
if ~debug
[handle, image_path, region] = vot('rectangle');
end

if debug
    seq = debug_vot();
else
    str_start = strfind(image_path,'sequences/');
    str_end = strfind(image_path,'/color/');
    seqname = image_path(str_start+10:str_end-1);
    
    seq.s_frames{1} = image_path;
    seq.init_rect = region;
    seq.name = [seqname,'00'];
end

params = SetParams_VOT16(seq);
[params, data] = PrepareData(params);
disp('end initialization!')

data.obj.rects(1,:) = seq.init_rect;

frame =1;
while true
    data.seq.frame = frame;
    if frame>1
        if debug
            image_path = seq.s_frames{frame};
        else
            [handle, image_path] = handle.frame(handle);
        end
        %
        if isempty(image_path)
            break;
        end
        %
        params.s_frames{frame} = image_path;
    end
    %
    data.seq.im = imread(params.s_frames{data.seq.frame});
    if size(data.seq.im,3) > 1 && data.seq.colorImage == false
        data.seq.im = data.seq.im(:,:,1);
    end
    %
    disp('load image!')
    %
    [params, data] = Detection(params, data);
    %
    disp('detection finish!')
    %
    [params, data] = FilterUpdate(params, data);
    disp('end tracking!')
    data.seq.im_prev = data.seq.im;
    if ~debug 
        handle = handle.report(handle, data.obj.rects(frame,:));
    end
    Visualization(params.visualization, params.selector, data.seq.frame, data.seq.im, data.obj.pos, data.obj.target_sz);
    frame = frame +1;
    disp(['frame:',num2str(frame)]);
end

if ~debug
    handle.quit(handle);
end

end
